
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "JobServer.h"
#include "ArgsGridMethodsEcho.h"
#include "ArgsJobServerGetJobAd.h"
#include "ArgsJobServerFetchJobData.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::grid;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  JobServer::packageName  = string ("com.redhat.grid");
string  JobServer::className    = string ("jobserver");
uint8_t JobServer::md5Sum[MD5_LEN]   =
    {0xde,0x9a,0xab,0x90,0x38,0xc0,0xbc,0xa1,0xa,0x77,0x95,0xd6,0x5e,0x43,0x87,0x17};

JobServer::JobServer (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    CondorPlatform = "";
    CondorVersion = "";
    DaemonStartTime = 0;
    schedulerRef = ::qpid::management::ObjectId();
    Pool = "";
    System = "";
    Machine = "";
    MyAddress = "";
    Name = "";
    PublicNetworkIpAddr = "";
    MonitorSelfAge = 0;
    MonitorSelfCPUUsage = 0.;
    MonitorSelfImageSize = 0.;
    MonitorSelfRegisteredSocketCount = 0;
    MonitorSelfResidentSetSize = 0;
    MonitorSelfTime = 0;



}

JobServer::~JobServer ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void JobServer::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void JobServer::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (10); // Config Element Count
    buf.putShort       (6); // Inst Element Count
    buf.putShort       (3); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "CondorPlatform";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The Condor platform string for the daemon's platform";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "CondorVersion";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The Condor version string for the daemon's version";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "DaemonStartTime";
    ft[TYPE] = TYPE_ABSTIME;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[UNIT] = "nanosecond";
    ft[DESC] = "Number of nanoseconds since epoch when the daemon     was started";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "schedulerRef";
    ft[TYPE] = TYPE_REF;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Pool";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "System";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Machine";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MyAddress";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "PublicNetworkIpAddr";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "";
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "MonitorSelfAge";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfCPUUsage";
    ft[TYPE] = TYPE_DOUBLE;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfImageSize";
    ft[TYPE] = TYPE_DOUBLE;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfRegisteredSocketCount";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfResidentSetSize";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "MonitorSelfTime";
    ft[TYPE] = TYPE_ABSTIME;
    buf.putMap(ft);


    // Methods
    ft.clear();
    ft[NAME] =  "echo";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "sequence";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "body";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "GetJobAd";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Id";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Job's Id, the string ClusterId.ProcId";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "JobAd";
    ft[TYPE] = TYPE_FTABLE;
    ft[DIR] = "O";
    ft[DESC] = "(name,value,type) tuples; Values are INTEGER, FLOAT,         STRING and EXPR. The EXPR value is not first class,         it is an unquoted, with double quotes, string";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "FetchJobData";
    ft[ARGCOUNT] = 5;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Id";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "Job's Id, the string ClusterId.ProcId";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "File";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Start";
    ft[TYPE] = TYPE_S32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "End";
    ft[TYPE] = TYPE_S32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Data";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "O";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string JobServer::getKey() const
{
    std::stringstream key;

    key << schedulerRef.getV2Key() << ",";
    key << Pool << ",";
    key << System << ",";
    key << Name;
    return key.str();
}



void JobServer::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["CondorPlatform"] = ::qpid::types::Variant(CondorPlatform);
    _map["CondorVersion"] = ::qpid::types::Variant(CondorVersion);
    _map["DaemonStartTime"] = ::qpid::types::Variant(DaemonStartTime);
    _map["schedulerRef"] = ::qpid::types::Variant(schedulerRef);
    _map["Pool"] = ::qpid::types::Variant(Pool);
    _map["System"] = ::qpid::types::Variant(System);
    _map["Machine"] = ::qpid::types::Variant(Machine);
    _map["MyAddress"] = ::qpid::types::Variant(MyAddress);
    _map["Name"] = ::qpid::types::Variant(Name);
    _map["PublicNetworkIpAddr"] = ::qpid::types::Variant(PublicNetworkIpAddr);

    }

    if (includeStatistics) {
        instChanged = false;




    _map["MonitorSelfAge"] = ::qpid::types::Variant(MonitorSelfAge);
    _map["MonitorSelfCPUUsage"] = ::qpid::types::Variant(MonitorSelfCPUUsage);
    _map["MonitorSelfImageSize"] = ::qpid::types::Variant(MonitorSelfImageSize);
    _map["MonitorSelfRegisteredSocketCount"] = ::qpid::types::Variant(MonitorSelfRegisteredSocketCount);
    _map["MonitorSelfResidentSetSize"] = ::qpid::types::Variant(MonitorSelfResidentSetSize);
    _map["MonitorSelfTime"] = ::qpid::types::Variant(MonitorSelfTime);


    // Maintenance of hi-lo statistics


    }
}

void JobServer::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("CondorPlatform")) != _map.end()) {
        CondorPlatform = (_i->second).getString();
    }
    if ((_i = _map.find("CondorVersion")) != _map.end()) {
        CondorVersion = (_i->second).getString();
    }
    if ((_i = _map.find("DaemonStartTime")) != _map.end()) {
        DaemonStartTime = _i->second;
    }
    if ((_i = _map.find("schedulerRef")) != _map.end()) {
        schedulerRef = _i->second;
    }
    if ((_i = _map.find("Pool")) != _map.end()) {
        Pool = (_i->second).getString();
    }
    if ((_i = _map.find("System")) != _map.end()) {
        System = (_i->second).getString();
    }
    if ((_i = _map.find("Machine")) != _map.end()) {
        Machine = (_i->second).getString();
    }
    if ((_i = _map.find("MyAddress")) != _map.end()) {
        MyAddress = (_i->second).getString();
    }
    if ((_i = _map.find("Name")) != _map.end()) {
        Name = (_i->second).getString();
    }
    if ((_i = _map.find("PublicNetworkIpAddr")) != _map.end()) {
        PublicNetworkIpAddr = (_i->second).getString();
    }

}

void JobServer::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap, const string& userId)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "echo") {
        ArgsGridMethodsEcho ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("sequence")) != inMap.end()) {
            ioArgs.io_sequence = _i->second;
        }
        if ((_i = inMap.find("body")) != inMap.end()) {
            ioArgs.io_body = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_ECHO, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_ECHO, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["sequence"] = ::qpid::types::Variant(ioArgs.io_sequence);
        outMap["body"] = ::qpid::types::Variant(ioArgs.io_body);
        return;
    }

    if (methodName == "GetJobAd") {
        ArgsJobServerGetJobAd ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Id")) != inMap.end()) {
            ioArgs.i_Id = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_GETJOBAD, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_GETJOBAD, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["JobAd"] = ::qpid::types::Variant(ioArgs.o_JobAd);
        return;
    }

    if (methodName == "FetchJobData") {
        ArgsJobServerFetchJobData ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Id")) != inMap.end()) {
            ioArgs.i_Id = (_i->second).getString();
        }
        if ((_i = inMap.find("File")) != inMap.end()) {
            ioArgs.i_File = (_i->second).getString();
        }
        if ((_i = inMap.find("Start")) != inMap.end()) {
            ioArgs.i_Start = _i->second;
        }
        if ((_i = inMap.find("End")) != inMap.end()) {
            ioArgs.i_End = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_FETCHJOBDATA, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_FETCHJOBDATA, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Data"] = ::qpid::types::Variant(ioArgs.o_Data);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
