
#ifndef _MANAGEMENT_SUBMISSION_
#define _MANAGEMENT_SUBMISSION_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace grid {


class Submission : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];


    // Properties
    ::qpid::management::ObjectId jobserverRef;
    std::string Name;
    std::string Owner;
    int64_t QDate;

    // Statistics


    // Per-Thread Statistics
    struct PerThreadStats {
        uint32_t  Idle;
        uint32_t  Running;
        uint32_t  Removed;
        uint32_t  Completed;
        uint32_t  Held;

    };

    struct PerThreadStats** perThreadStatsArray;

    inline struct PerThreadStats* getThreadStats() {
        int idx = getThreadIndex();
        struct PerThreadStats* threadStats = perThreadStatsArray[idx];
        if (threadStats == 0) {
            threadStats = new(PerThreadStats);
            perThreadStatsArray[idx] = threadStats;
            threadStats->Idle = 0;
            threadStats->Running = 0;
            threadStats->Removed = 0;
            threadStats->Completed = 0;
            threadStats->Held = 0;

        }
        return threadStats;
    }

    void aggregatePerThreadStats(struct PerThreadStats*) const;

  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap,
                  const std::string& userId);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }


    Submission(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent);
    ~Submission();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_ECHO = 1;
    static const uint32_t METHOD_GETJOBSUMMARIES = 2;

    // Accessor Methods
    inline void set_jobserverRef (const ::qpid::management::ObjectId& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        jobserverRef = val;
        configChanged = true;
    }
    inline const ::qpid::management::ObjectId& get_jobserverRef() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return jobserverRef;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_Owner (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Owner = val;
        configChanged = true;
    }
    inline const std::string& get_Owner() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Owner;
    }
    inline void set_QDate (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        QDate = val;
        configChanged = true;
    }
    inline int64_t get_QDate() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return QDate;
    }
    inline void inc_Idle (uint32_t by = 1) {
        getThreadStats()->Idle += by;
        instChanged = true;
    }
    inline void dec_Idle (uint32_t by = 1) {
        getThreadStats()->Idle -= by;
        instChanged = true;
    }
    inline void inc_Running (uint32_t by = 1) {
        getThreadStats()->Running += by;
        instChanged = true;
    }
    inline void dec_Running (uint32_t by = 1) {
        getThreadStats()->Running -= by;
        instChanged = true;
    }
    inline void inc_Removed (uint32_t by = 1) {
        getThreadStats()->Removed += by;
        instChanged = true;
    }
    inline void dec_Removed (uint32_t by = 1) {
        getThreadStats()->Removed -= by;
        instChanged = true;
    }
    inline void inc_Completed (uint32_t by = 1) {
        getThreadStats()->Completed += by;
        instChanged = true;
    }
    inline void dec_Completed (uint32_t by = 1) {
        getThreadStats()->Completed -= by;
        instChanged = true;
    }
    inline void inc_Held (uint32_t by = 1) {
        getThreadStats()->Held += by;
        instChanged = true;
    }
    inline void dec_Held (uint32_t by = 1) {
        getThreadStats()->Held -= by;
        instChanged = true;
    }

};

}}}}

#endif  /*!_MANAGEMENT_SUBMISSION_*/
