
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "Grid.h"
#include "ArgsGridMethodsEcho.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::grid;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  Grid::packageName  = string ("com.redhat.grid");
string  Grid::className    = string ("grid");
uint8_t Grid::md5Sum[MD5_LEN]   =
    {0x0,0x7,0x2c,0xe6,0x7e,0xba,0x9e,0xe5,0xab,0xa0,0x32,0x8,0x44,0x82,0x8,0x19};

Grid::Grid (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    Pool = "";
    Name = "";
    ScheddName = "";
    Owner = "";
    JobLimit = 0;
    SubmitLimit = 0;
    GridResourceUnavailableTime = 0;
    NumJobs = 0;
    SubmitsInProgress = 0;
    SubmitsQueued = 0;
    SubmitsAllowed = 0;
    SubmitsWanted = 0;
    RunningJobs = 0;
    IdleJobs = 0;


    // Optional properties start out not-present
    for (uint8_t idx = 0; idx < 1; idx++)
        presenceMask[idx] = 0;


}

Grid::~Grid ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Grid::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Grid::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (7); // Config Element Count
    buf.putShort       (7); // Inst Element Count
    buf.putShort       (1); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "Pool";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "ScheddName";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Owner";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "JobLimit";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Maximum number of jobs that can be in the process       of being submitted at any time.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "SubmitLimit";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Limit on the number of jobs that will be submitted       to the grid resource at once.";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "GridResourceUnavailableTime";
    ft[TYPE] = TYPE_ABSTIME;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 1;
    ft[UNIT] = "nanosecond";
    ft[DESC] = "If present, the Grid is down for the specified        amount of time.";
    buf.putMap(ft);


    // Statistics
    ft.clear();
    ft[NAME] = "NumJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "SubmitsInProgress";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "SubmitsQueued";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "SubmitsAllowed";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "SubmitsWanted";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "RunningJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "IdleJobs";
    ft[TYPE] = TYPE_U32;
    buf.putMap(ft);


    // Methods
    ft.clear();
    ft[NAME] =  "echo";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "sequence";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "IO";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "body";
    ft[TYPE] = TYPE_LSTR;
    ft[DIR] = "IO";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string Grid::getKey() const
{
    std::stringstream key;

    key << Pool;
    return key.str();
}



void Grid::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["Pool"] = ::qpid::types::Variant(Pool);
    _map["Name"] = ::qpid::types::Variant(Name);
    _map["ScheddName"] = ::qpid::types::Variant(ScheddName);
    _map["Owner"] = ::qpid::types::Variant(Owner);
    _map["JobLimit"] = ::qpid::types::Variant(JobLimit);
    _map["SubmitLimit"] = ::qpid::types::Variant(SubmitLimit);
    if (presenceMask[presenceByte_GridResourceUnavailableTime] & presenceMask_GridResourceUnavailableTime) {
        _map["GridResourceUnavailableTime"] = ::qpid::types::Variant(GridResourceUnavailableTime);
    }

    }

    if (includeStatistics) {
        instChanged = false;




    _map["NumJobs"] = ::qpid::types::Variant(NumJobs);
    _map["SubmitsInProgress"] = ::qpid::types::Variant(SubmitsInProgress);
    _map["SubmitsQueued"] = ::qpid::types::Variant(SubmitsQueued);
    _map["SubmitsAllowed"] = ::qpid::types::Variant(SubmitsAllowed);
    _map["SubmitsWanted"] = ::qpid::types::Variant(SubmitsWanted);
    _map["RunningJobs"] = ::qpid::types::Variant(RunningJobs);
    _map["IdleJobs"] = ::qpid::types::Variant(IdleJobs);


    // Maintenance of hi-lo statistics


    }
}

void Grid::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    bool _found;

    if ((_i = _map.find("Pool")) != _map.end()) {
        Pool = (_i->second).getString();
    }
    if ((_i = _map.find("Name")) != _map.end()) {
        Name = (_i->second).getString();
    }
    if ((_i = _map.find("ScheddName")) != _map.end()) {
        ScheddName = (_i->second).getString();
    }
    if ((_i = _map.find("Owner")) != _map.end()) {
        Owner = (_i->second).getString();
    }
    if ((_i = _map.find("JobLimit")) != _map.end()) {
        JobLimit = _i->second;
    }
    if ((_i = _map.find("SubmitLimit")) != _map.end()) {
        SubmitLimit = _i->second;
    }
    _found = false;
    if ((_i = _map.find("GridResourceUnavailableTime")) != _map.end()) {
        GridResourceUnavailableTime = _i->second;
        _found = true;
    }
    if (_found) {
        presenceMask[presenceByte_GridResourceUnavailableTime] |= presenceMask_GridResourceUnavailableTime;
    }

}

void Grid::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap, const string& userId)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "echo") {
        ArgsGridMethodsEcho ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("sequence")) != inMap.end()) {
            ioArgs.io_sequence = _i->second;
        }
        if ((_i = inMap.find("body")) != inMap.end()) {
            ioArgs.io_body = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_ECHO, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_ECHO, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["sequence"] = ::qpid::types::Variant(ioArgs.io_sequence);
        outMap["body"] = ::qpid::types::Variant(ioArgs.io_body);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
