
#ifndef _MANAGEMENT_GRID_
#define _MANAGEMENT_GRID_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace grid {


class Grid : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];

    uint8_t presenceMask[1];
    static const uint8_t presenceByte_GridResourceUnavailableTime = 0;
    static const uint8_t presenceMask_GridResourceUnavailableTime = 1;



    // Properties
    std::string Pool;
    std::string Name;
    std::string ScheddName;
    std::string Owner;
    uint32_t JobLimit;
    uint32_t SubmitLimit;
    int64_t GridResourceUnavailableTime;

    // Statistics
    uint32_t  NumJobs;
    uint32_t  SubmitsInProgress;
    uint32_t  SubmitsQueued;
    uint32_t  SubmitsAllowed;
    uint32_t  SubmitsWanted;
    uint32_t  RunningJobs;
    uint32_t  IdleJobs;


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap,
                  const std::string& userId);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }


    Grid(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Grid();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_ECHO = 1;

    // Accessor Methods
    inline void set_Pool (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Pool = val;
        configChanged = true;
    }
    inline const std::string& get_Pool() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Pool;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_ScheddName (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ScheddName = val;
        configChanged = true;
    }
    inline const std::string& get_ScheddName() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ScheddName;
    }
    inline void set_Owner (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Owner = val;
        configChanged = true;
    }
    inline const std::string& get_Owner() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Owner;
    }
    inline void set_JobLimit (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobLimit = val;
        configChanged = true;
    }
    inline uint32_t get_JobLimit() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobLimit;
    }
    inline void set_SubmitLimit (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SubmitLimit = val;
        configChanged = true;
    }
    inline uint32_t get_SubmitLimit() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SubmitLimit;
    }
    inline void set_GridResourceUnavailableTime (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        GridResourceUnavailableTime = val;
        presenceMask[presenceByte_GridResourceUnavailableTime] |= presenceMask_GridResourceUnavailableTime;
        configChanged = true;
    }
    inline int64_t get_GridResourceUnavailableTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return GridResourceUnavailableTime;
    }
    inline void clr_GridResourceUnavailableTime() {
        presenceMask[presenceByte_GridResourceUnavailableTime] &= ~presenceMask_GridResourceUnavailableTime;
        configChanged = true;
    }
    inline bool isSet_GridResourceUnavailableTime() {
        return (presenceMask[presenceByte_GridResourceUnavailableTime] & presenceMask_GridResourceUnavailableTime) != 0;
    }
    inline void set_NumJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        NumJobs = val;
        instChanged = true;
    }
    inline uint32_t get_NumJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return NumJobs;
    }
    inline void set_SubmitsInProgress (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SubmitsInProgress = val;
        instChanged = true;
    }
    inline uint32_t get_SubmitsInProgress() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SubmitsInProgress;
    }
    inline void set_SubmitsQueued (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SubmitsQueued = val;
        instChanged = true;
    }
    inline uint32_t get_SubmitsQueued() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SubmitsQueued;
    }
    inline void set_SubmitsAllowed (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SubmitsAllowed = val;
        instChanged = true;
    }
    inline uint32_t get_SubmitsAllowed() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SubmitsAllowed;
    }
    inline void set_SubmitsWanted (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SubmitsWanted = val;
        instChanged = true;
    }
    inline uint32_t get_SubmitsWanted() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SubmitsWanted;
    }
    inline void set_RunningJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        RunningJobs = val;
        instChanged = true;
    }
    inline uint32_t get_RunningJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return RunningJobs;
    }
    inline void set_IdleJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        IdleJobs = val;
        instChanged = true;
    }
    inline uint32_t get_IdleJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return IdleJobs;
    }

};

}}}}

#endif  /*!_MANAGEMENT_GRID_*/
