
#ifndef _MANAGEMENT_NEGOTIATOR_
#define _MANAGEMENT_NEGOTIATOR_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace grid {


class Negotiator : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];


    // Properties
    std::string Pool;
    std::string System;
    std::string Name;
    std::string Machine;
    std::string MyAddress;
    std::string CondorPlatform;
    std::string CondorVersion;
    int64_t DaemonStartTime;

    // Statistics
    uint32_t  MonitorSelfAge;
    double  MonitorSelfCPUUsage;
    double  MonitorSelfImageSize;
    uint32_t  MonitorSelfRegisteredSocketCount;
    uint32_t  MonitorSelfResidentSetSize;
    int64_t  MonitorSelfTime;
    double  MatchRate;
    double  MatchRateSustained;
    uint32_t  Matches;
    uint32_t  Duration;
    uint32_t  Phase1Duration;
    uint32_t  Phase2Duration;
    uint32_t  Phase3Duration;
    uint32_t  Phase4Duration;
    uint32_t  SlotShareIter;
    uint32_t  NumSchedulers;
    uint32_t  ActiveSubmitterCount;
    std::string  SubmittersFailed;
    std::string  SubmittersOutOfTime;
    std::string  SubmittersShareLimit;
    uint32_t  NumIdleJobs;
    uint32_t  NumJobsConsidered;
    uint32_t  Rejections;
    uint32_t  TotalSlots;
    uint32_t  CandidateSlots;
    uint32_t  TrimmedSlots;
    int64_t  Time;
    int64_t  End;
    uint32_t  Period;


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap,
                  const std::string& userId);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }


    Negotiator(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Negotiator();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_ECHO = 1;
    static const uint32_t METHOD_GETLIMITS = 2;
    static const uint32_t METHOD_SETLIMIT = 3;
    static const uint32_t METHOD_GETSTATS = 4;
    static const uint32_t METHOD_SETPRIORITY = 5;
    static const uint32_t METHOD_SETPRIORITYFACTOR = 6;
    static const uint32_t METHOD_SETUSAGE = 7;
    static const uint32_t METHOD_GETRAWCONFIG = 8;
    static const uint32_t METHOD_SETRAWCONFIG = 9;
    static const uint32_t METHOD_RECONFIG = 10;

    // Accessor Methods
    inline void set_Pool (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Pool = val;
        configChanged = true;
    }
    inline const std::string& get_Pool() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Pool;
    }
    inline void set_System (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        System = val;
        configChanged = true;
    }
    inline const std::string& get_System() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return System;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_Machine (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Machine = val;
        configChanged = true;
    }
    inline const std::string& get_Machine() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Machine;
    }
    inline void set_MyAddress (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MyAddress = val;
        configChanged = true;
    }
    inline const std::string& get_MyAddress() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MyAddress;
    }
    inline void set_CondorPlatform (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CondorPlatform = val;
        configChanged = true;
    }
    inline const std::string& get_CondorPlatform() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CondorPlatform;
    }
    inline void set_CondorVersion (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CondorVersion = val;
        configChanged = true;
    }
    inline const std::string& get_CondorVersion() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CondorVersion;
    }
    inline void set_DaemonStartTime (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        DaemonStartTime = val;
        configChanged = true;
    }
    inline int64_t get_DaemonStartTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return DaemonStartTime;
    }
    inline void set_MonitorSelfAge (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfAge = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfAge() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfAge;
    }
    inline void set_MonitorSelfCPUUsage (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfCPUUsage = val;
        instChanged = true;
    }
    inline double get_MonitorSelfCPUUsage() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfCPUUsage;
    }
    inline void set_MonitorSelfImageSize (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfImageSize = val;
        instChanged = true;
    }
    inline double get_MonitorSelfImageSize() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfImageSize;
    }
    inline void set_MonitorSelfRegisteredSocketCount (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfRegisteredSocketCount = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfRegisteredSocketCount() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfRegisteredSocketCount;
    }
    inline void set_MonitorSelfResidentSetSize (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfResidentSetSize = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfResidentSetSize() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfResidentSetSize;
    }
    inline void set_MonitorSelfTime (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfTime = val;
        instChanged = true;
    }
    inline int64_t get_MonitorSelfTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfTime;
    }
    inline void set_MatchRate (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MatchRate = val;
        instChanged = true;
    }
    inline double get_MatchRate() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MatchRate;
    }
    inline void set_MatchRateSustained (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MatchRateSustained = val;
        instChanged = true;
    }
    inline double get_MatchRateSustained() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MatchRateSustained;
    }
    inline void set_Matches (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Matches = val;
        instChanged = true;
    }
    inline uint32_t get_Matches() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Matches;
    }
    inline void set_Duration (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Duration = val;
        instChanged = true;
    }
    inline uint32_t get_Duration() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Duration;
    }
    inline void set_Phase1Duration (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Phase1Duration = val;
        instChanged = true;
    }
    inline uint32_t get_Phase1Duration() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Phase1Duration;
    }
    inline void set_Phase2Duration (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Phase2Duration = val;
        instChanged = true;
    }
    inline uint32_t get_Phase2Duration() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Phase2Duration;
    }
    inline void set_Phase3Duration (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Phase3Duration = val;
        instChanged = true;
    }
    inline uint32_t get_Phase3Duration() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Phase3Duration;
    }
    inline void set_Phase4Duration (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Phase4Duration = val;
        instChanged = true;
    }
    inline uint32_t get_Phase4Duration() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Phase4Duration;
    }
    inline void set_SlotShareIter (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SlotShareIter = val;
        instChanged = true;
    }
    inline uint32_t get_SlotShareIter() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SlotShareIter;
    }
    inline void set_NumSchedulers (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        NumSchedulers = val;
        instChanged = true;
    }
    inline uint32_t get_NumSchedulers() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return NumSchedulers;
    }
    inline void set_ActiveSubmitterCount (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ActiveSubmitterCount = val;
        instChanged = true;
    }
    inline uint32_t get_ActiveSubmitterCount() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ActiveSubmitterCount;
    }
    inline void set_SubmittersFailed (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SubmittersFailed = val;
        instChanged = true;
    }
    inline const std::string& get_SubmittersFailed() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SubmittersFailed;
    }
    inline void set_SubmittersOutOfTime (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SubmittersOutOfTime = val;
        instChanged = true;
    }
    inline const std::string& get_SubmittersOutOfTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SubmittersOutOfTime;
    }
    inline void set_SubmittersShareLimit (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SubmittersShareLimit = val;
        instChanged = true;
    }
    inline const std::string& get_SubmittersShareLimit() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SubmittersShareLimit;
    }
    inline void set_NumIdleJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        NumIdleJobs = val;
        instChanged = true;
    }
    inline uint32_t get_NumIdleJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return NumIdleJobs;
    }
    inline void set_NumJobsConsidered (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        NumJobsConsidered = val;
        instChanged = true;
    }
    inline uint32_t get_NumJobsConsidered() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return NumJobsConsidered;
    }
    inline void set_Rejections (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Rejections = val;
        instChanged = true;
    }
    inline uint32_t get_Rejections() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Rejections;
    }
    inline void set_TotalSlots (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalSlots = val;
        instChanged = true;
    }
    inline uint32_t get_TotalSlots() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalSlots;
    }
    inline void set_CandidateSlots (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CandidateSlots = val;
        instChanged = true;
    }
    inline uint32_t get_CandidateSlots() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CandidateSlots;
    }
    inline void set_TrimmedSlots (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TrimmedSlots = val;
        instChanged = true;
    }
    inline uint32_t get_TrimmedSlots() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TrimmedSlots;
    }
    inline void set_Time (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Time = val;
        instChanged = true;
    }
    inline int64_t get_Time() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Time;
    }
    inline void set_End (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        End = val;
        instChanged = true;
    }
    inline int64_t get_End() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return End;
    }
    inline void set_Period (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Period = val;
        instChanged = true;
    }
    inline uint32_t get_Period() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Period;
    }

};

}}}}

#endif  /*!_MANAGEMENT_NEGOTIATOR_*/
