
#ifndef _MANAGEMENT_SCHEDULER_
#define _MANAGEMENT_SCHEDULER_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace grid {


class Scheduler : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];


    // Properties
    std::string CondorPlatform;
    std::string CondorVersion;
    int64_t DaemonStartTime;
    std::string Pool;
    std::string System;
    int64_t JobQueueBirthdate;
    uint32_t MaxJobsRunning;
    std::string Machine;
    std::string MyAddress;
    std::string Name;
    uint32_t WindowedStatWidth;

    // Statistics
    uint32_t  MonitorSelfAge;
    double  MonitorSelfCPUUsage;
    double  MonitorSelfImageSize;
    uint32_t  MonitorSelfRegisteredSocketCount;
    uint32_t  MonitorSelfResidentSetSize;
    int64_t  MonitorSelfTime;
    uint32_t  NumUsers;
    uint32_t  TotalHeldJobs;
    uint32_t  TotalIdleJobs;
    uint32_t  TotalJobAds;
    uint32_t  TotalRemovedJobs;
    uint32_t  TotalRunningJobs;
    uint32_t  UpdateInterval;
    uint32_t  JobsSubmitted;
    double  JobSubmissionRate;
    uint32_t  JobsCompleted;
    double  JobCompletionRate;
    uint32_t  JobsExited;
    uint32_t  ShadowExceptions;
    uint32_t  JobsSubmittedCum;
    uint32_t  JobsCompletedCum;
    uint32_t  JobsExitedCum;
    uint32_t  ShadowExceptionsCum;
    uint32_t  JobsStartedCum;
    uint32_t  JobsStarted;
    double  JobStartRate;
    double  MeanTimeToStartCum;
    double  MeanRunningTimeCum;
    uint64_t  SumTimeToStartCum;
    uint64_t  SumRunningTimeCum;
    double  MeanTimeToStart;
    double  MeanRunningTime;


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap,
                  const std::string& userId);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }


    Scheduler(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Scheduler();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_ECHO = 1;
    static const uint32_t METHOD_SUBMITJOB = 2;
    static const uint32_t METHOD_SETJOBATTRIBUTE = 3;
    static const uint32_t METHOD_HOLDJOB = 4;
    static const uint32_t METHOD_RELEASEJOB = 5;
    static const uint32_t METHOD_REMOVEJOB = 6;

    // Accessor Methods
    inline void set_CondorPlatform (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CondorPlatform = val;
        configChanged = true;
    }
    inline const std::string& get_CondorPlatform() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CondorPlatform;
    }
    inline void set_CondorVersion (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CondorVersion = val;
        configChanged = true;
    }
    inline const std::string& get_CondorVersion() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CondorVersion;
    }
    inline void set_DaemonStartTime (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        DaemonStartTime = val;
        configChanged = true;
    }
    inline int64_t get_DaemonStartTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return DaemonStartTime;
    }
    inline void set_Pool (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Pool = val;
        configChanged = true;
    }
    inline const std::string& get_Pool() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Pool;
    }
    inline void set_System (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        System = val;
        configChanged = true;
    }
    inline const std::string& get_System() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return System;
    }
    inline void set_JobQueueBirthdate (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobQueueBirthdate = val;
        configChanged = true;
    }
    inline int64_t get_JobQueueBirthdate() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobQueueBirthdate;
    }
    inline void set_MaxJobsRunning (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MaxJobsRunning = val;
        configChanged = true;
    }
    inline uint32_t get_MaxJobsRunning() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MaxJobsRunning;
    }
    inline void set_Machine (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Machine = val;
        configChanged = true;
    }
    inline const std::string& get_Machine() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Machine;
    }
    inline void set_MyAddress (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MyAddress = val;
        configChanged = true;
    }
    inline const std::string& get_MyAddress() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MyAddress;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_WindowedStatWidth (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        WindowedStatWidth = val;
        configChanged = true;
    }
    inline uint32_t get_WindowedStatWidth() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return WindowedStatWidth;
    }
    inline void set_MonitorSelfAge (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfAge = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfAge() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfAge;
    }
    inline void set_MonitorSelfCPUUsage (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfCPUUsage = val;
        instChanged = true;
    }
    inline double get_MonitorSelfCPUUsage() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfCPUUsage;
    }
    inline void set_MonitorSelfImageSize (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfImageSize = val;
        instChanged = true;
    }
    inline double get_MonitorSelfImageSize() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfImageSize;
    }
    inline void set_MonitorSelfRegisteredSocketCount (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfRegisteredSocketCount = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfRegisteredSocketCount() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfRegisteredSocketCount;
    }
    inline void set_MonitorSelfResidentSetSize (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfResidentSetSize = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfResidentSetSize() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfResidentSetSize;
    }
    inline void set_MonitorSelfTime (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfTime = val;
        instChanged = true;
    }
    inline int64_t get_MonitorSelfTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfTime;
    }
    inline void set_NumUsers (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        NumUsers = val;
        instChanged = true;
    }
    inline uint32_t get_NumUsers() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return NumUsers;
    }
    inline void set_TotalHeldJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalHeldJobs = val;
        instChanged = true;
    }
    inline uint32_t get_TotalHeldJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalHeldJobs;
    }
    inline void set_TotalIdleJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalIdleJobs = val;
        instChanged = true;
    }
    inline uint32_t get_TotalIdleJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalIdleJobs;
    }
    inline void set_TotalJobAds (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalJobAds = val;
        instChanged = true;
    }
    inline uint32_t get_TotalJobAds() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalJobAds;
    }
    inline void set_TotalRemovedJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalRemovedJobs = val;
        instChanged = true;
    }
    inline uint32_t get_TotalRemovedJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalRemovedJobs;
    }
    inline void set_TotalRunningJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalRunningJobs = val;
        instChanged = true;
    }
    inline uint32_t get_TotalRunningJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalRunningJobs;
    }
    inline void set_UpdateInterval (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        UpdateInterval = val;
        instChanged = true;
    }
    inline uint32_t get_UpdateInterval() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return UpdateInterval;
    }
    inline void set_JobsSubmitted (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobsSubmitted = val;
        instChanged = true;
    }
    inline uint32_t get_JobsSubmitted() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobsSubmitted;
    }
    inline void set_JobSubmissionRate (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobSubmissionRate = val;
        instChanged = true;
    }
    inline double get_JobSubmissionRate() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobSubmissionRate;
    }
    inline void set_JobsCompleted (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobsCompleted = val;
        instChanged = true;
    }
    inline uint32_t get_JobsCompleted() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobsCompleted;
    }
    inline void set_JobCompletionRate (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobCompletionRate = val;
        instChanged = true;
    }
    inline double get_JobCompletionRate() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobCompletionRate;
    }
    inline void set_JobsExited (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobsExited = val;
        instChanged = true;
    }
    inline uint32_t get_JobsExited() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobsExited;
    }
    inline void set_ShadowExceptions (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ShadowExceptions = val;
        instChanged = true;
    }
    inline uint32_t get_ShadowExceptions() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ShadowExceptions;
    }
    inline void set_JobsSubmittedCum (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobsSubmittedCum = val;
        instChanged = true;
    }
    inline uint32_t get_JobsSubmittedCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobsSubmittedCum;
    }
    inline void set_JobsCompletedCum (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobsCompletedCum = val;
        instChanged = true;
    }
    inline uint32_t get_JobsCompletedCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobsCompletedCum;
    }
    inline void set_JobsExitedCum (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobsExitedCum = val;
        instChanged = true;
    }
    inline uint32_t get_JobsExitedCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobsExitedCum;
    }
    inline void set_ShadowExceptionsCum (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ShadowExceptionsCum = val;
        instChanged = true;
    }
    inline uint32_t get_ShadowExceptionsCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ShadowExceptionsCum;
    }
    inline void set_JobsStartedCum (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobsStartedCum = val;
        instChanged = true;
    }
    inline uint32_t get_JobsStartedCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobsStartedCum;
    }
    inline void set_JobsStarted (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobsStarted = val;
        instChanged = true;
    }
    inline uint32_t get_JobsStarted() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobsStarted;
    }
    inline void set_JobStartRate (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobStartRate = val;
        instChanged = true;
    }
    inline double get_JobStartRate() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobStartRate;
    }
    inline void set_MeanTimeToStartCum (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MeanTimeToStartCum = val;
        instChanged = true;
    }
    inline double get_MeanTimeToStartCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MeanTimeToStartCum;
    }
    inline void set_MeanRunningTimeCum (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MeanRunningTimeCum = val;
        instChanged = true;
    }
    inline double get_MeanRunningTimeCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MeanRunningTimeCum;
    }
    inline void set_SumTimeToStartCum (uint64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SumTimeToStartCum = val;
        instChanged = true;
    }
    inline uint64_t get_SumTimeToStartCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SumTimeToStartCum;
    }
    inline void set_SumRunningTimeCum (uint64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SumRunningTimeCum = val;
        instChanged = true;
    }
    inline uint64_t get_SumRunningTimeCum() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SumRunningTimeCum;
    }
    inline void set_MeanTimeToStart (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MeanTimeToStart = val;
        instChanged = true;
    }
    inline double get_MeanTimeToStart() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MeanTimeToStart;
    }
    inline void set_MeanRunningTime (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MeanRunningTime = val;
        instChanged = true;
    }
    inline double get_MeanRunningTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MeanRunningTime;
    }

};

}}}}

#endif  /*!_MANAGEMENT_SCHEDULER_*/
