
#ifndef _MANAGEMENT_SLOT_
#define _MANAGEMENT_SLOT_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace grid {


class Slot : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];

    uint8_t presenceMask[3];
    static const uint8_t presenceByte_AccountingGroup = 0;
    static const uint8_t presenceMask_AccountingGroup = 1;
    static const uint8_t presenceByte_ClientMachine = 0;
    static const uint8_t presenceMask_ClientMachine = 2;
    static const uint8_t presenceByte_ConcurrencyLimits = 0;
    static const uint8_t presenceMask_ConcurrencyLimits = 4;
    static const uint8_t presenceByte_CurrentRank = 0;
    static const uint8_t presenceMask_CurrentRank = 8;
    static const uint8_t presenceByte_GlobalJobId = 0;
    static const uint8_t presenceMask_GlobalJobId = 16;
    static const uint8_t presenceByte_JobId = 0;
    static const uint8_t presenceMask_JobId = 32;
    static const uint8_t presenceByte_JobStart = 0;
    static const uint8_t presenceMask_JobStart = 64;
    static const uint8_t presenceByte_PreemptingConcurrencyLimits = 0;
    static const uint8_t presenceMask_PreemptingConcurrencyLimits = 128;
    static const uint8_t presenceByte_PreemptingOwner = 1;
    static const uint8_t presenceMask_PreemptingOwner = 1;
    static const uint8_t presenceByte_PreemptingUser = 1;
    static const uint8_t presenceMask_PreemptingUser = 2;
    static const uint8_t presenceByte_PreemptingRank = 1;
    static const uint8_t presenceMask_PreemptingRank = 4;
    static const uint8_t presenceByte_RemoteOwner = 1;
    static const uint8_t presenceMask_RemoteOwner = 8;
    static const uint8_t presenceByte_RemoteUser = 1;
    static const uint8_t presenceMask_RemoteUser = 16;
    static const uint8_t presenceByte_TotalClaimRunTime = 1;
    static const uint8_t presenceMask_TotalClaimRunTime = 32;
    static const uint8_t presenceByte_TotalClaimSuspendTime = 1;
    static const uint8_t presenceMask_TotalClaimSuspendTime = 64;
    static const uint8_t presenceByte_TotalJobRunTime = 1;
    static const uint8_t presenceMask_TotalJobRunTime = 128;
    static const uint8_t presenceByte_TotalJobSuspendTime = 2;
    static const uint8_t presenceMask_TotalJobSuspendTime = 1;



    // Properties
    std::string CondorPlatform;
    std::string CondorVersion;
    int64_t DaemonStartTime;
    std::string Pool;
    std::string System;
    std::string AccountingGroup;
    std::string Activity;
    std::string Arch;
    std::string CheckpointPlatform;
    std::string ClientMachine;
    std::string ConcurrencyLimits;
    uint32_t Cpus;
    double CurrentRank;
    uint32_t Disk;
    int64_t EnteredCurrentActivity;
    int64_t EnteredCurrentState;
    std::string FileSystemDomain;
    std::string GlobalJobId;
    std::string IsValidCheckpointPlatform;
    std::string JobId;
    int64_t JobStart;
    uint32_t KFlops;
    int64_t LastBenchmark;
    int64_t LastFetchWorkCompleted;
    int64_t LastFetchWorkSpawned;
    int64_t LastPeriodicCheckpoint;
    std::string Machine;
    std::string MaxJobRetirementTime;
    uint32_t Memory;
    uint32_t Mips;
    std::string MyAddress;
    std::string Name;
    int32_t NextFetchWorkDelay;
    std::string OpSys;
    std::string PreemptingConcurrencyLimits;
    std::string PreemptingOwner;
    std::string PreemptingUser;
    double PreemptingRank;
    std::string RemoteOwner;
    std::string RemoteUser;
    std::string Requirements;
    std::string Rank;
    uint32_t SlotID;
    std::string Start;
    std::string StarterAbilityList;
    std::string State;
    uint32_t TimeToLive;
    uint32_t TotalClaimRunTime;
    uint32_t TotalClaimSuspendTime;
    uint32_t TotalCpus;
    uint32_t TotalDisk;
    uint32_t TotalJobRunTime;
    uint32_t TotalJobSuspendTime;
    uint32_t TotalMemory;
    uint32_t TotalSlots;
    uint32_t TotalVirtualMemory;
    std::string UidDomain;
    uint32_t VirtualMemory;
    uint32_t WindowsBuildNumber;
    uint32_t WindowsMajorVersion;
    uint32_t WindowsMinorVersion;

    // Statistics
    uint32_t  MonitorSelfAge;
    double  MonitorSelfCPUUsage;
    double  MonitorSelfImageSize;
    uint32_t  MonitorSelfRegisteredSocketCount;
    uint32_t  MonitorSelfResidentSetSize;
    int64_t  MonitorSelfTime;
    uint32_t  ClockDay;
    uint32_t  ClockMin;
    double  CondorLoadAvg;
    uint32_t  ConsoleIdle;
    uint32_t  ImageSize;
    uint32_t  KeyboardIdle;
    double  LoadAvg;
    int64_t  MyCurrentTime;
    double  TotalCondorLoadAvg;
    double  TotalLoadAvg;
    uint32_t  TotalTimeBackfillBusy;
    uint32_t  TotalTimeBackfillIdle;
    uint32_t  TotalTimeBackfillKilling;
    uint32_t  TotalTimeClaimedBusy;
    uint32_t  TotalTimeClaimedIdle;
    uint32_t  TotalTimeClaimedRetiring;
    uint32_t  TotalTimeClaimedSuspended;
    uint32_t  TotalTimeMatchedIdle;
    uint32_t  TotalTimeOwnerIdle;
    uint32_t  TotalTimePreemptingKilling;
    uint32_t  TotalTimePreemptingVacating;
    uint32_t  TotalTimeUnclaimedBenchmarking;
    uint32_t  TotalTimeUnclaimedIdle;


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap,
                  const std::string& userId);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }


    Slot(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~Slot();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_ECHO = 1;

    // Accessor Methods
    inline void set_CondorPlatform (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CondorPlatform = val;
        configChanged = true;
    }
    inline const std::string& get_CondorPlatform() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CondorPlatform;
    }
    inline void set_CondorVersion (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CondorVersion = val;
        configChanged = true;
    }
    inline const std::string& get_CondorVersion() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CondorVersion;
    }
    inline void set_DaemonStartTime (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        DaemonStartTime = val;
        configChanged = true;
    }
    inline int64_t get_DaemonStartTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return DaemonStartTime;
    }
    inline void set_Pool (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Pool = val;
        configChanged = true;
    }
    inline const std::string& get_Pool() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Pool;
    }
    inline void set_System (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        System = val;
        configChanged = true;
    }
    inline const std::string& get_System() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return System;
    }
    inline void set_AccountingGroup (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        AccountingGroup = val;
        presenceMask[presenceByte_AccountingGroup] |= presenceMask_AccountingGroup;
        configChanged = true;
    }
    inline const std::string& get_AccountingGroup() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return AccountingGroup;
    }
    inline void clr_AccountingGroup() {
        presenceMask[presenceByte_AccountingGroup] &= ~presenceMask_AccountingGroup;
        configChanged = true;
    }
    inline bool isSet_AccountingGroup() {
        return (presenceMask[presenceByte_AccountingGroup] & presenceMask_AccountingGroup) != 0;
    }
    inline void set_Activity (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Activity = val;
        configChanged = true;
    }
    inline const std::string& get_Activity() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Activity;
    }
    inline void set_Arch (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Arch = val;
        configChanged = true;
    }
    inline const std::string& get_Arch() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Arch;
    }
    inline void set_CheckpointPlatform (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CheckpointPlatform = val;
        configChanged = true;
    }
    inline const std::string& get_CheckpointPlatform() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CheckpointPlatform;
    }
    inline void set_ClientMachine (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ClientMachine = val;
        presenceMask[presenceByte_ClientMachine] |= presenceMask_ClientMachine;
        configChanged = true;
    }
    inline const std::string& get_ClientMachine() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ClientMachine;
    }
    inline void clr_ClientMachine() {
        presenceMask[presenceByte_ClientMachine] &= ~presenceMask_ClientMachine;
        configChanged = true;
    }
    inline bool isSet_ClientMachine() {
        return (presenceMask[presenceByte_ClientMachine] & presenceMask_ClientMachine) != 0;
    }
    inline void set_ConcurrencyLimits (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ConcurrencyLimits = val;
        presenceMask[presenceByte_ConcurrencyLimits] |= presenceMask_ConcurrencyLimits;
        configChanged = true;
    }
    inline const std::string& get_ConcurrencyLimits() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ConcurrencyLimits;
    }
    inline void clr_ConcurrencyLimits() {
        presenceMask[presenceByte_ConcurrencyLimits] &= ~presenceMask_ConcurrencyLimits;
        configChanged = true;
    }
    inline bool isSet_ConcurrencyLimits() {
        return (presenceMask[presenceByte_ConcurrencyLimits] & presenceMask_ConcurrencyLimits) != 0;
    }
    inline void set_Cpus (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Cpus = val;
        configChanged = true;
    }
    inline uint32_t get_Cpus() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Cpus;
    }
    inline void set_CurrentRank (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CurrentRank = val;
        presenceMask[presenceByte_CurrentRank] |= presenceMask_CurrentRank;
        configChanged = true;
    }
    inline double get_CurrentRank() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CurrentRank;
    }
    inline void clr_CurrentRank() {
        presenceMask[presenceByte_CurrentRank] &= ~presenceMask_CurrentRank;
        configChanged = true;
    }
    inline bool isSet_CurrentRank() {
        return (presenceMask[presenceByte_CurrentRank] & presenceMask_CurrentRank) != 0;
    }
    inline void set_Disk (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Disk = val;
        configChanged = true;
    }
    inline uint32_t get_Disk() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Disk;
    }
    inline void set_EnteredCurrentActivity (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        EnteredCurrentActivity = val;
        configChanged = true;
    }
    inline int64_t get_EnteredCurrentActivity() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return EnteredCurrentActivity;
    }
    inline void set_EnteredCurrentState (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        EnteredCurrentState = val;
        configChanged = true;
    }
    inline int64_t get_EnteredCurrentState() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return EnteredCurrentState;
    }
    inline void set_FileSystemDomain (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        FileSystemDomain = val;
        configChanged = true;
    }
    inline const std::string& get_FileSystemDomain() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return FileSystemDomain;
    }
    inline void set_GlobalJobId (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        GlobalJobId = val;
        presenceMask[presenceByte_GlobalJobId] |= presenceMask_GlobalJobId;
        configChanged = true;
    }
    inline const std::string& get_GlobalJobId() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return GlobalJobId;
    }
    inline void clr_GlobalJobId() {
        presenceMask[presenceByte_GlobalJobId] &= ~presenceMask_GlobalJobId;
        configChanged = true;
    }
    inline bool isSet_GlobalJobId() {
        return (presenceMask[presenceByte_GlobalJobId] & presenceMask_GlobalJobId) != 0;
    }
    inline void set_IsValidCheckpointPlatform (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        IsValidCheckpointPlatform = val;
        configChanged = true;
    }
    inline const std::string& get_IsValidCheckpointPlatform() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return IsValidCheckpointPlatform;
    }
    inline void set_JobId (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobId = val;
        presenceMask[presenceByte_JobId] |= presenceMask_JobId;
        configChanged = true;
    }
    inline const std::string& get_JobId() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobId;
    }
    inline void clr_JobId() {
        presenceMask[presenceByte_JobId] &= ~presenceMask_JobId;
        configChanged = true;
    }
    inline bool isSet_JobId() {
        return (presenceMask[presenceByte_JobId] & presenceMask_JobId) != 0;
    }
    inline void set_JobStart (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobStart = val;
        presenceMask[presenceByte_JobStart] |= presenceMask_JobStart;
        configChanged = true;
    }
    inline int64_t get_JobStart() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobStart;
    }
    inline void clr_JobStart() {
        presenceMask[presenceByte_JobStart] &= ~presenceMask_JobStart;
        configChanged = true;
    }
    inline bool isSet_JobStart() {
        return (presenceMask[presenceByte_JobStart] & presenceMask_JobStart) != 0;
    }
    inline void set_KFlops (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        KFlops = val;
        configChanged = true;
    }
    inline uint32_t get_KFlops() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return KFlops;
    }
    inline void set_LastBenchmark (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        LastBenchmark = val;
        configChanged = true;
    }
    inline int64_t get_LastBenchmark() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return LastBenchmark;
    }
    inline void set_LastFetchWorkCompleted (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        LastFetchWorkCompleted = val;
        configChanged = true;
    }
    inline int64_t get_LastFetchWorkCompleted() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return LastFetchWorkCompleted;
    }
    inline void set_LastFetchWorkSpawned (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        LastFetchWorkSpawned = val;
        configChanged = true;
    }
    inline int64_t get_LastFetchWorkSpawned() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return LastFetchWorkSpawned;
    }
    inline void set_LastPeriodicCheckpoint (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        LastPeriodicCheckpoint = val;
        configChanged = true;
    }
    inline int64_t get_LastPeriodicCheckpoint() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return LastPeriodicCheckpoint;
    }
    inline void set_Machine (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Machine = val;
        configChanged = true;
    }
    inline const std::string& get_Machine() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Machine;
    }
    inline void set_MaxJobRetirementTime (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MaxJobRetirementTime = val;
        configChanged = true;
    }
    inline const std::string& get_MaxJobRetirementTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MaxJobRetirementTime;
    }
    inline void set_Memory (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Memory = val;
        configChanged = true;
    }
    inline uint32_t get_Memory() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Memory;
    }
    inline void set_Mips (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Mips = val;
        configChanged = true;
    }
    inline uint32_t get_Mips() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Mips;
    }
    inline void set_MyAddress (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MyAddress = val;
        configChanged = true;
    }
    inline const std::string& get_MyAddress() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MyAddress;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_NextFetchWorkDelay (int32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        NextFetchWorkDelay = val;
        configChanged = true;
    }
    inline int32_t get_NextFetchWorkDelay() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return NextFetchWorkDelay;
    }
    inline void set_OpSys (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        OpSys = val;
        configChanged = true;
    }
    inline const std::string& get_OpSys() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return OpSys;
    }
    inline void set_PreemptingConcurrencyLimits (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        PreemptingConcurrencyLimits = val;
        presenceMask[presenceByte_PreemptingConcurrencyLimits] |= presenceMask_PreemptingConcurrencyLimits;
        configChanged = true;
    }
    inline const std::string& get_PreemptingConcurrencyLimits() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return PreemptingConcurrencyLimits;
    }
    inline void clr_PreemptingConcurrencyLimits() {
        presenceMask[presenceByte_PreemptingConcurrencyLimits] &= ~presenceMask_PreemptingConcurrencyLimits;
        configChanged = true;
    }
    inline bool isSet_PreemptingConcurrencyLimits() {
        return (presenceMask[presenceByte_PreemptingConcurrencyLimits] & presenceMask_PreemptingConcurrencyLimits) != 0;
    }
    inline void set_PreemptingOwner (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        PreemptingOwner = val;
        presenceMask[presenceByte_PreemptingOwner] |= presenceMask_PreemptingOwner;
        configChanged = true;
    }
    inline const std::string& get_PreemptingOwner() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return PreemptingOwner;
    }
    inline void clr_PreemptingOwner() {
        presenceMask[presenceByte_PreemptingOwner] &= ~presenceMask_PreemptingOwner;
        configChanged = true;
    }
    inline bool isSet_PreemptingOwner() {
        return (presenceMask[presenceByte_PreemptingOwner] & presenceMask_PreemptingOwner) != 0;
    }
    inline void set_PreemptingUser (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        PreemptingUser = val;
        presenceMask[presenceByte_PreemptingUser] |= presenceMask_PreemptingUser;
        configChanged = true;
    }
    inline const std::string& get_PreemptingUser() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return PreemptingUser;
    }
    inline void clr_PreemptingUser() {
        presenceMask[presenceByte_PreemptingUser] &= ~presenceMask_PreemptingUser;
        configChanged = true;
    }
    inline bool isSet_PreemptingUser() {
        return (presenceMask[presenceByte_PreemptingUser] & presenceMask_PreemptingUser) != 0;
    }
    inline void set_PreemptingRank (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        PreemptingRank = val;
        presenceMask[presenceByte_PreemptingRank] |= presenceMask_PreemptingRank;
        configChanged = true;
    }
    inline double get_PreemptingRank() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return PreemptingRank;
    }
    inline void clr_PreemptingRank() {
        presenceMask[presenceByte_PreemptingRank] &= ~presenceMask_PreemptingRank;
        configChanged = true;
    }
    inline bool isSet_PreemptingRank() {
        return (presenceMask[presenceByte_PreemptingRank] & presenceMask_PreemptingRank) != 0;
    }
    inline void set_RemoteOwner (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        RemoteOwner = val;
        presenceMask[presenceByte_RemoteOwner] |= presenceMask_RemoteOwner;
        configChanged = true;
    }
    inline const std::string& get_RemoteOwner() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return RemoteOwner;
    }
    inline void clr_RemoteOwner() {
        presenceMask[presenceByte_RemoteOwner] &= ~presenceMask_RemoteOwner;
        configChanged = true;
    }
    inline bool isSet_RemoteOwner() {
        return (presenceMask[presenceByte_RemoteOwner] & presenceMask_RemoteOwner) != 0;
    }
    inline void set_RemoteUser (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        RemoteUser = val;
        presenceMask[presenceByte_RemoteUser] |= presenceMask_RemoteUser;
        configChanged = true;
    }
    inline const std::string& get_RemoteUser() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return RemoteUser;
    }
    inline void clr_RemoteUser() {
        presenceMask[presenceByte_RemoteUser] &= ~presenceMask_RemoteUser;
        configChanged = true;
    }
    inline bool isSet_RemoteUser() {
        return (presenceMask[presenceByte_RemoteUser] & presenceMask_RemoteUser) != 0;
    }
    inline void set_Requirements (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Requirements = val;
        configChanged = true;
    }
    inline const std::string& get_Requirements() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Requirements;
    }
    inline void set_Rank (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Rank = val;
        configChanged = true;
    }
    inline const std::string& get_Rank() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Rank;
    }
    inline void set_SlotID (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        SlotID = val;
        configChanged = true;
    }
    inline uint32_t get_SlotID() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return SlotID;
    }
    inline void set_Start (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Start = val;
        configChanged = true;
    }
    inline const std::string& get_Start() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Start;
    }
    inline void set_StarterAbilityList (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        StarterAbilityList = val;
        configChanged = true;
    }
    inline const std::string& get_StarterAbilityList() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return StarterAbilityList;
    }
    inline void set_State (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        State = val;
        configChanged = true;
    }
    inline const std::string& get_State() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return State;
    }
    inline void set_TimeToLive (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TimeToLive = val;
        configChanged = true;
    }
    inline uint32_t get_TimeToLive() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TimeToLive;
    }
    inline void set_TotalClaimRunTime (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalClaimRunTime = val;
        presenceMask[presenceByte_TotalClaimRunTime] |= presenceMask_TotalClaimRunTime;
        configChanged = true;
    }
    inline uint32_t get_TotalClaimRunTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalClaimRunTime;
    }
    inline void clr_TotalClaimRunTime() {
        presenceMask[presenceByte_TotalClaimRunTime] &= ~presenceMask_TotalClaimRunTime;
        configChanged = true;
    }
    inline bool isSet_TotalClaimRunTime() {
        return (presenceMask[presenceByte_TotalClaimRunTime] & presenceMask_TotalClaimRunTime) != 0;
    }
    inline void set_TotalClaimSuspendTime (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalClaimSuspendTime = val;
        presenceMask[presenceByte_TotalClaimSuspendTime] |= presenceMask_TotalClaimSuspendTime;
        configChanged = true;
    }
    inline uint32_t get_TotalClaimSuspendTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalClaimSuspendTime;
    }
    inline void clr_TotalClaimSuspendTime() {
        presenceMask[presenceByte_TotalClaimSuspendTime] &= ~presenceMask_TotalClaimSuspendTime;
        configChanged = true;
    }
    inline bool isSet_TotalClaimSuspendTime() {
        return (presenceMask[presenceByte_TotalClaimSuspendTime] & presenceMask_TotalClaimSuspendTime) != 0;
    }
    inline void set_TotalCpus (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalCpus = val;
        configChanged = true;
    }
    inline uint32_t get_TotalCpus() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalCpus;
    }
    inline void set_TotalDisk (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalDisk = val;
        configChanged = true;
    }
    inline uint32_t get_TotalDisk() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalDisk;
    }
    inline void set_TotalJobRunTime (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalJobRunTime = val;
        presenceMask[presenceByte_TotalJobRunTime] |= presenceMask_TotalJobRunTime;
        configChanged = true;
    }
    inline uint32_t get_TotalJobRunTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalJobRunTime;
    }
    inline void clr_TotalJobRunTime() {
        presenceMask[presenceByte_TotalJobRunTime] &= ~presenceMask_TotalJobRunTime;
        configChanged = true;
    }
    inline bool isSet_TotalJobRunTime() {
        return (presenceMask[presenceByte_TotalJobRunTime] & presenceMask_TotalJobRunTime) != 0;
    }
    inline void set_TotalJobSuspendTime (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalJobSuspendTime = val;
        presenceMask[presenceByte_TotalJobSuspendTime] |= presenceMask_TotalJobSuspendTime;
        configChanged = true;
    }
    inline uint32_t get_TotalJobSuspendTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalJobSuspendTime;
    }
    inline void clr_TotalJobSuspendTime() {
        presenceMask[presenceByte_TotalJobSuspendTime] &= ~presenceMask_TotalJobSuspendTime;
        configChanged = true;
    }
    inline bool isSet_TotalJobSuspendTime() {
        return (presenceMask[presenceByte_TotalJobSuspendTime] & presenceMask_TotalJobSuspendTime) != 0;
    }
    inline void set_TotalMemory (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalMemory = val;
        configChanged = true;
    }
    inline uint32_t get_TotalMemory() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalMemory;
    }
    inline void set_TotalSlots (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalSlots = val;
        configChanged = true;
    }
    inline uint32_t get_TotalSlots() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalSlots;
    }
    inline void set_TotalVirtualMemory (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalVirtualMemory = val;
        configChanged = true;
    }
    inline uint32_t get_TotalVirtualMemory() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalVirtualMemory;
    }
    inline void set_UidDomain (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        UidDomain = val;
        configChanged = true;
    }
    inline const std::string& get_UidDomain() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return UidDomain;
    }
    inline void set_VirtualMemory (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        VirtualMemory = val;
        configChanged = true;
    }
    inline uint32_t get_VirtualMemory() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return VirtualMemory;
    }
    inline void set_WindowsBuildNumber (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        WindowsBuildNumber = val;
        configChanged = true;
    }
    inline uint32_t get_WindowsBuildNumber() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return WindowsBuildNumber;
    }
    inline void set_WindowsMajorVersion (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        WindowsMajorVersion = val;
        configChanged = true;
    }
    inline uint32_t get_WindowsMajorVersion() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return WindowsMajorVersion;
    }
    inline void set_WindowsMinorVersion (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        WindowsMinorVersion = val;
        configChanged = true;
    }
    inline uint32_t get_WindowsMinorVersion() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return WindowsMinorVersion;
    }
    inline void set_MonitorSelfAge (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfAge = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfAge() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfAge;
    }
    inline void set_MonitorSelfCPUUsage (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfCPUUsage = val;
        instChanged = true;
    }
    inline double get_MonitorSelfCPUUsage() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfCPUUsage;
    }
    inline void set_MonitorSelfImageSize (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfImageSize = val;
        instChanged = true;
    }
    inline double get_MonitorSelfImageSize() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfImageSize;
    }
    inline void set_MonitorSelfRegisteredSocketCount (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfRegisteredSocketCount = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfRegisteredSocketCount() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfRegisteredSocketCount;
    }
    inline void set_MonitorSelfResidentSetSize (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfResidentSetSize = val;
        instChanged = true;
    }
    inline uint32_t get_MonitorSelfResidentSetSize() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfResidentSetSize;
    }
    inline void set_MonitorSelfTime (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MonitorSelfTime = val;
        instChanged = true;
    }
    inline int64_t get_MonitorSelfTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MonitorSelfTime;
    }
    inline void set_ClockDay (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ClockDay = val;
        instChanged = true;
    }
    inline uint32_t get_ClockDay() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ClockDay;
    }
    inline void set_ClockMin (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ClockMin = val;
        instChanged = true;
    }
    inline uint32_t get_ClockMin() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ClockMin;
    }
    inline void set_CondorLoadAvg (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        CondorLoadAvg = val;
        instChanged = true;
    }
    inline double get_CondorLoadAvg() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return CondorLoadAvg;
    }
    inline void set_ConsoleIdle (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ConsoleIdle = val;
        instChanged = true;
    }
    inline uint32_t get_ConsoleIdle() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ConsoleIdle;
    }
    inline void set_ImageSize (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ImageSize = val;
        instChanged = true;
    }
    inline uint32_t get_ImageSize() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ImageSize;
    }
    inline void set_KeyboardIdle (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        KeyboardIdle = val;
        instChanged = true;
    }
    inline uint32_t get_KeyboardIdle() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return KeyboardIdle;
    }
    inline void set_LoadAvg (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        LoadAvg = val;
        instChanged = true;
    }
    inline double get_LoadAvg() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return LoadAvg;
    }
    inline void set_MyCurrentTime (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        MyCurrentTime = val;
        instChanged = true;
    }
    inline int64_t get_MyCurrentTime() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return MyCurrentTime;
    }
    inline void set_TotalCondorLoadAvg (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalCondorLoadAvg = val;
        instChanged = true;
    }
    inline double get_TotalCondorLoadAvg() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalCondorLoadAvg;
    }
    inline void set_TotalLoadAvg (double val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalLoadAvg = val;
        instChanged = true;
    }
    inline double get_TotalLoadAvg() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalLoadAvg;
    }
    inline void set_TotalTimeBackfillBusy (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeBackfillBusy = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeBackfillBusy() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeBackfillBusy;
    }
    inline void set_TotalTimeBackfillIdle (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeBackfillIdle = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeBackfillIdle() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeBackfillIdle;
    }
    inline void set_TotalTimeBackfillKilling (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeBackfillKilling = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeBackfillKilling() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeBackfillKilling;
    }
    inline void set_TotalTimeClaimedBusy (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeClaimedBusy = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeClaimedBusy() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeClaimedBusy;
    }
    inline void set_TotalTimeClaimedIdle (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeClaimedIdle = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeClaimedIdle() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeClaimedIdle;
    }
    inline void set_TotalTimeClaimedRetiring (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeClaimedRetiring = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeClaimedRetiring() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeClaimedRetiring;
    }
    inline void set_TotalTimeClaimedSuspended (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeClaimedSuspended = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeClaimedSuspended() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeClaimedSuspended;
    }
    inline void set_TotalTimeMatchedIdle (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeMatchedIdle = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeMatchedIdle() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeMatchedIdle;
    }
    inline void set_TotalTimeOwnerIdle (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeOwnerIdle = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeOwnerIdle() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeOwnerIdle;
    }
    inline void set_TotalTimePreemptingKilling (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimePreemptingKilling = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimePreemptingKilling() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimePreemptingKilling;
    }
    inline void set_TotalTimePreemptingVacating (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimePreemptingVacating = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimePreemptingVacating() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimePreemptingVacating;
    }
    inline void set_TotalTimeUnclaimedBenchmarking (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeUnclaimedBenchmarking = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeUnclaimedBenchmarking() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeUnclaimedBenchmarking;
    }
    inline void set_TotalTimeUnclaimedIdle (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        TotalTimeUnclaimedIdle = val;
        instChanged = true;
    }
    inline uint32_t get_TotalTimeUnclaimedIdle() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return TotalTimeUnclaimedIdle;
    }

};

}}}}

#endif  /*!_MANAGEMENT_SLOT_*/
