
#ifndef _MANAGEMENT_SUBMITTER_
#define _MANAGEMENT_SUBMITTER_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace grid {


class Submitter : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];


    // Properties
    ::qpid::management::ObjectId schedulerRef;
    int64_t JobQueueBirthdate;
    std::string Machine;
    std::string Name;
    std::string Owner;
    std::string ScheddName;

    // Statistics
    uint32_t  HeldJobs;
    uint32_t  IdleJobs;
    uint32_t  RunningJobs;


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap,
                  const std::string& userId);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }


    Submitter(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject, ::qpid::management::Manageable* _parent);
    ~Submitter();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_ECHO = 1;

    // Accessor Methods
    inline void set_schedulerRef (const ::qpid::management::ObjectId& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        schedulerRef = val;
        configChanged = true;
    }
    inline const ::qpid::management::ObjectId& get_schedulerRef() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return schedulerRef;
    }
    inline void set_JobQueueBirthdate (int64_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        JobQueueBirthdate = val;
        configChanged = true;
    }
    inline int64_t get_JobQueueBirthdate() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return JobQueueBirthdate;
    }
    inline void set_Machine (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Machine = val;
        configChanged = true;
    }
    inline const std::string& get_Machine() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Machine;
    }
    inline void set_Name (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Name = val;
        configChanged = true;
    }
    inline const std::string& get_Name() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Name;
    }
    inline void set_Owner (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        Owner = val;
        configChanged = true;
    }
    inline const std::string& get_Owner() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return Owner;
    }
    inline void set_ScheddName (const std::string& val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        ScheddName = val;
        configChanged = true;
    }
    inline const std::string& get_ScheddName() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return ScheddName;
    }
    inline void set_HeldJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        HeldJobs = val;
        instChanged = true;
    }
    inline uint32_t get_HeldJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return HeldJobs;
    }
    inline void set_IdleJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        IdleJobs = val;
        instChanged = true;
    }
    inline uint32_t get_IdleJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return IdleJobs;
    }
    inline void set_RunningJobs (uint32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        RunningJobs = val;
        instChanged = true;
    }
    inline uint32_t get_RunningJobs() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return RunningJobs;
    }

};

}}}}

#endif  /*!_MANAGEMENT_SUBMITTER_*/
