
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "CondorTrigger.h"
#include "ArgsCondorTriggerGetTriggerName.h"
#include "ArgsCondorTriggerGetTriggerQuery.h"
#include "ArgsCondorTriggerGetTriggerText.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::grid;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  CondorTrigger::packageName  = string ("com.redhat.grid");
string  CondorTrigger::className    = string ("condortrigger");
uint8_t CondorTrigger::md5Sum[MD5_LEN]   =
    {0xb,0x80,0x43,0xbc,0x77,0x59,0x93,0x40,0x3b,0x91,0xcb,0x1c,0x7b,0x10,0x12,0xec};

CondorTrigger::CondorTrigger (ManagementAgent*, Manageable* _core, uint32_t _TriggerId) :
    ManagementObject(_core),TriggerId(_TriggerId)
{
    
    TriggerName = "";
    TriggerQuery = "";
    TriggerText = "";



}

CondorTrigger::~CondorTrigger ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void CondorTrigger::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void CondorTrigger::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (4); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (3); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "TriggerId";
    ft[TYPE] = TYPE_U32;
    ft[ACCESS] = ACCESS_RC;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "A unique trigger id assigned by the trigger evaluation                       service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TriggerName";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "A descriptive string for the trigger";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TriggerQuery";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The classad constraint used to evaluate the trigger";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TriggerText";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "The event text the trigger will generate";
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "GetTriggerName";
    ft[ARGCOUNT] = 1;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "GetTriggerQuery";
    ft[ARGCOUNT] = 1;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Query";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "O";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "GetTriggerText";
    ft[ARGCOUNT] = 1;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Text";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "O";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string CondorTrigger::getKey() const
{
    std::stringstream key;

    key << TriggerId;
    return key.str();
}



void CondorTrigger::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["TriggerId"] = ::qpid::types::Variant(TriggerId);
    _map["TriggerName"] = ::qpid::types::Variant(TriggerName);
    _map["TriggerQuery"] = ::qpid::types::Variant(TriggerQuery);
    _map["TriggerText"] = ::qpid::types::Variant(TriggerText);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void CondorTrigger::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("TriggerId")) != _map.end()) {
        TriggerId = _i->second;
    }
    if ((_i = _map.find("TriggerName")) != _map.end()) {
        TriggerName = (_i->second).getString();
    }
    if ((_i = _map.find("TriggerQuery")) != _map.end()) {
        TriggerQuery = (_i->second).getString();
    }
    if ((_i = _map.find("TriggerText")) != _map.end()) {
        TriggerText = (_i->second).getString();
    }

}

void CondorTrigger::doMethod (string& methodName, const ::qpid::types::Variant::Map&, ::qpid::types::Variant::Map& outMap, const string& userId)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "GetTriggerName") {
        ArgsCondorTriggerGetTriggerName ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        bool allow = coreObject->AuthorizeMethod(METHOD_GETTRIGGERNAME, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_GETTRIGGERNAME, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Name"] = ::qpid::types::Variant(ioArgs.o_Name);
        return;
    }

    if (methodName == "GetTriggerQuery") {
        ArgsCondorTriggerGetTriggerQuery ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        bool allow = coreObject->AuthorizeMethod(METHOD_GETTRIGGERQUERY, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_GETTRIGGERQUERY, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Query"] = ::qpid::types::Variant(ioArgs.o_Query);
        return;
    }

    if (methodName == "GetTriggerText") {
        ArgsCondorTriggerGetTriggerText ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        bool allow = coreObject->AuthorizeMethod(METHOD_GETTRIGGERTEXT, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_GETTRIGGERTEXT, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Text"] = ::qpid::types::Variant(ioArgs.o_Text);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
