
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "CondorTriggerService.h"
#include "ArgsCondorTriggerServiceAddTrigger.h"
#include "ArgsCondorTriggerServiceRemoveTrigger.h"
#include "ArgsCondorTriggerServiceSetTriggerName.h"
#include "ArgsCondorTriggerServiceSetTriggerQuery.h"
#include "ArgsCondorTriggerServiceSetTriggerText.h"
#include "ArgsCondorTriggerServiceSetEvalInterval.h"
#include "ArgsCondorTriggerServiceGetEvalInterval.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::grid;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  CondorTriggerService::packageName  = string ("com.redhat.grid");
string  CondorTriggerService::className    = string ("condortriggerservice");
uint8_t CondorTriggerService::md5Sum[MD5_LEN]   =
    {0x7a,0x39,0x49,0xd5,0x59,0x75,0x5d,0x9f,0x1b,0xe8,0x5f,0xfb,0x2f,0xce,0x2e,0x3a};

CondorTriggerService::CondorTriggerService (ManagementAgent*, Manageable* _core) :
    ManagementObject(_core)
{
    
    EvalInterval = 0;



}

CondorTriggerService::~CondorTriggerService ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void CondorTriggerService::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void CondorTriggerService::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (1); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (7); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "EvalInterval";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RW;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "AddTrigger";
    ft[ARGCOUNT] = 3;
    ft[DESC] = "Add a new trigger to the service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "A string that describes/identifies the trigger";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Query";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "The classad constraint used to evaluate the trigger";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Text";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    ft[DESC] = "The event text that will be generated for the trigger.                     This is in the form of a quoted string separated by +                     signs to indicate classad attributes that should be                     included in the text";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "RemoveTrigger";
    ft[ARGCOUNT] = 1;
    ft[DESC] = "Remove a trigger from the service";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TriggerID";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    ft[DESC] = "The ID of the trigger to be removed";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetTriggerName";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TriggerID";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Name";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetTriggerQuery";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TriggerID";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Query";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetTriggerText";
    ft[ARGCOUNT] = 2;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TriggerID";
    ft[TYPE] = TYPE_U32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Text";
    ft[TYPE] = TYPE_SSTR;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "SetEvalInterval";
    ft[ARGCOUNT] = 1;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Interval";
    ft[TYPE] = TYPE_S32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] =  "GetEvalInterval";
    ft[ARGCOUNT] = 1;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "Interval";
    ft[TYPE] = TYPE_S32;
    ft[DIR] = "O";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string CondorTriggerService::getKey() const
{
    std::stringstream key;


    return key.str();
}



void CondorTriggerService::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["EvalInterval"] = ::qpid::types::Variant(EvalInterval);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void CondorTriggerService::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("EvalInterval")) != _map.end()) {
        EvalInterval = _i->second;
    }

}

void CondorTriggerService::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap, const string& userId)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "AddTrigger") {
        ArgsCondorTriggerServiceAddTrigger ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        if ((_i = inMap.find("Query")) != inMap.end()) {
            ioArgs.i_Query = (_i->second).getString();
        }
        if ((_i = inMap.find("Text")) != inMap.end()) {
            ioArgs.i_Text = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_ADDTRIGGER, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_ADDTRIGGER, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "RemoveTrigger") {
        ArgsCondorTriggerServiceRemoveTrigger ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("TriggerID")) != inMap.end()) {
            ioArgs.i_TriggerID = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_REMOVETRIGGER, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_REMOVETRIGGER, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "SetTriggerName") {
        ArgsCondorTriggerServiceSetTriggerName ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("TriggerID")) != inMap.end()) {
            ioArgs.i_TriggerID = _i->second;
        }
        if ((_i = inMap.find("Name")) != inMap.end()) {
            ioArgs.i_Name = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_SETTRIGGERNAME, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_SETTRIGGERNAME, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "SetTriggerQuery") {
        ArgsCondorTriggerServiceSetTriggerQuery ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("TriggerID")) != inMap.end()) {
            ioArgs.i_TriggerID = _i->second;
        }
        if ((_i = inMap.find("Query")) != inMap.end()) {
            ioArgs.i_Query = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_SETTRIGGERQUERY, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_SETTRIGGERQUERY, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "SetTriggerText") {
        ArgsCondorTriggerServiceSetTriggerText ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("TriggerID")) != inMap.end()) {
            ioArgs.i_TriggerID = _i->second;
        }
        if ((_i = inMap.find("Text")) != inMap.end()) {
            ioArgs.i_Text = (_i->second).getString();
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_SETTRIGGERTEXT, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_SETTRIGGERTEXT, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "SetEvalInterval") {
        ArgsCondorTriggerServiceSetEvalInterval ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("Interval")) != inMap.end()) {
            ioArgs.i_Interval = _i->second;
        }
        bool allow = coreObject->AuthorizeMethod(METHOD_SETEVALINTERVAL, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_SETEVALINTERVAL, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        return;
    }

    if (methodName == "GetEvalInterval") {
        ArgsCondorTriggerServiceGetEvalInterval ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        bool allow = coreObject->AuthorizeMethod(METHOD_GETEVALINTERVAL, ioArgs, userId);
        if (allow)
            status = coreObject->ManagementMethod (METHOD_GETEVALINTERVAL, ioArgs, text);
        else
            status = Manageable::STATUS_FORBIDDEN;
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["Interval"] = ::qpid::types::Variant(ioArgs.o_Interval);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
