
#ifndef _MANAGEMENT_CONDORTRIGGERSERVICE_
#define _MANAGEMENT_CONDORTRIGGERSERVICE_

//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/ManagementObject.h"

namespace qpid {
    namespace management {
        class ManagementAgent;
    }
}

namespace qmf {
namespace com {
namespace redhat {
namespace grid {


class CondorTriggerService : public ::qpid::management::ManagementObject
{
  private:

    static std::string packageName;
    static std::string className;
    static uint8_t     md5Sum[MD5_LEN];


    // Properties
    int32_t EvalInterval;

    // Statistics


  public:
    static void writeSchema(std::string& schema);
    void mapEncodeValues(::qpid::types::Variant::Map& map,
                         bool includeProperties=true,
                         bool includeStatistics=true);
    void mapDecodeValues(const ::qpid::types::Variant::Map& map);
    void doMethod(std::string&           methodName,
                  const ::qpid::types::Variant::Map& inMap,
                  ::qpid::types::Variant::Map& outMap,
                  const std::string& userId);
    std::string getKey() const;


    writeSchemaCall_t getWriteSchemaCall() { return writeSchema; }

    // Stub for getInstChanged.  There are no statistics in this class.
    bool getInstChanged() { return false; }
    bool hasInst() { return false; }


    CondorTriggerService(::qpid::management::ManagementAgent* agent,
                            ::qpid::management::Manageable* coreObject);
    ~CondorTriggerService();

    

    static void registerSelf(::qpid::management::ManagementAgent* agent);
    std::string& getPackageName() const { return packageName; }
    std::string& getClassName() const { return className; }
    uint8_t* getMd5Sum() const { return md5Sum; }

    // Method IDs
    static const uint32_t METHOD_ADDTRIGGER = 1;
    static const uint32_t METHOD_REMOVETRIGGER = 2;
    static const uint32_t METHOD_SETTRIGGERNAME = 3;
    static const uint32_t METHOD_SETTRIGGERQUERY = 4;
    static const uint32_t METHOD_SETTRIGGERTEXT = 5;
    static const uint32_t METHOD_SETEVALINTERVAL = 6;
    static const uint32_t METHOD_GETEVALINTERVAL = 7;

    // Accessor Methods
    inline void set_EvalInterval (int32_t val) {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        EvalInterval = val;
        configChanged = true;
    }
    inline int32_t get_EvalInterval() {
        ::qpid::management::Mutex::ScopedLock mutex(accessLock);
        return EvalInterval;
    }

};

}}}}

#endif  /*!_MANAGEMENT_CONDORTRIGGERSERVICE_*/
