
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h" 
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "EventCondorTriggerNotify.h"

using namespace qmf::com::redhat::grid;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  EventCondorTriggerNotify::packageName  = string ("com.redhat.grid");
string  EventCondorTriggerNotify::eventName    = string ("CondorTriggerNotify");
uint8_t EventCondorTriggerNotify::md5Sum[16]   =
    {0x90,0x74,0x70,0x97,0x5b,0xf0,0xad,0x2e,0x72,0xcb,0x35,0x86,0x8,0xdc,0x7f,0xb1};

EventCondorTriggerNotify::EventCondorTriggerNotify (const std::string& _TriggerText,
        const int64_t _TriggerEvalTime) :
    TriggerText(_TriggerText),
    TriggerEvalTime(_TriggerEvalTime)
{}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
}

void EventCondorTriggerNotify::registerSelf(ManagementAgent* agent)
{
    agent->registerEvent(packageName, eventName, md5Sum, writeSchema);
}

void EventCondorTriggerNotify::writeSchema (std::string& schema)
{
    const int _bufSize = 65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_EVENT);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (eventName);   // Event Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (2); // Argument Count

    // Arguments
    ft.clear();
    ft[NAME] = "TriggerText";
    ft[TYPE] = TYPE_SSTR;
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "TriggerEvalTime";
    ft[TYPE] = TYPE_ABSTIME;
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}

void EventCondorTriggerNotify::encode(std::string& _sBuf) const
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);

    buf.putShortString(TriggerText);
    buf.putLongLong(TriggerEvalTime);


    uint32_t _bufLen = buf.getPosition();
    buf.reset();

    buf.getRawData(_sBuf, _bufLen);
}

void EventCondorTriggerNotify::mapEncode(::qpid::types::Variant::Map& map) const
{
    using namespace ::qpid::types;
    map["TriggerText"] = ::qpid::types::Variant(TriggerText);
    map["TriggerEvalTime"] = ::qpid::types::Variant(TriggerEvalTime);

}
